#define F_CPU 16000000
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <avr/pgmspace.h>
#include <stdio.h>
#include <stdlib.h>
#include "lcd.h"

/*#define 2 2
#define 3 3
#define 1 1
#define 0 0*/

void initButtons(void) {
	// pun butoanele pe intrare 
	DDRB &= ~(1 << PB0);
	DDRB &= ~(1 << PB1);
	DDRB &= ~(1 << PB2);
	DDRB &= ~(1 << PB3);

	// activez rezistenta de pull up
	PORTB |= (1 << PB0);
	PORTB |= (1 << PB1); 
	PORTB |= (1 << PB2);
	PORTB |= (1 << PB3);
}

int INITIAL_SIZE = 7;
typedef struct
{
	int x;
	int y;
} coord;

int head;
int tail;
int score;
coord point;
int lenght;
int defeat;
coord snake[MAX_SIZE];

void generate_coord(coord *input) 
{
    input->x = 15;
    input->y = 28;
}

void getRandPosition(int *x, int *y) 
{ 
	*x = (1 + rand() % (47 )); 
	*y = (1 + rand() % (50 )); 
}

void init_snake()
{
	int i;
	lcd_init();
	lcd_contrast(0x40);	

	matrix_init();

	lenght = INITIAL_SIZE;
	head   = INITIAL_SIZE - 1;
	tail   = 0;
	score  = 0;
	defeat = 0;
	directie = 0;
	getRandPosition(&point.x, &point.y);
	for (i = 0; i < lenght ; ++ i )
	{
		snake[i].x = Y_SIZE / 2;
		snake[i].y = i + INITIAL_SIZE;
	}

}

void set_snake(void)
{
	int i;
	for ( i = 0 ; i < head ; ++ i )
	{
		if ( i < tail )
		{
			set_pixel(snake[i].x, snake[i].y, 0);
		}else
		{
			set_pixel(snake[i].x, snake[i].y, 1);
		}
	}
	//setez mancare
	set_pixel(point.x,point.y, 1);

}

void advance(void)
{
	//int i;
	head = (head + 1) % MAX_SIZE;
	tail = (tail + 1) % MAX_SIZE;
	if (directie == 0)
	{
		//dreapta
		if ( head - 1 >= 0 )
		{
			snake[head].y = snake[head - 1].y + 1;
			snake[head].x = snake[head - 1].x;
		}else 
		{
			snake[head].y = snake[MAX_SIZE -1].y + 1;
			snake[head].x = snake[MAX_SIZE -1].x;
		}

	} else if (directie == 1)
	{
		//stanga
		if ( head - 1 >= 0 )
		{
			snake[head].y = snake[head - 1].y - 1;
			snake[head].x = snake[head - 1].x;
		}else 
		{
			snake[head].y = snake[MAX_SIZE -1].y - 1;
			snake[head].x = snake[MAX_SIZE -1].x;			
		}

	} else if (directie == 2)
	{
		//sus
		if ( head - 1 >= 0 )
		{
			snake[head].x = snake[head - 1].x - 1;
			snake[head].y = snake[head - 1].y;
		}else 
		{
			snake[head].x = snake[MAX_SIZE -1].x - 1;
			snake[head].y = snake[MAX_SIZE -1].y;			
		}		


	} else if (directie == 3)
	{
		//jos
		if ( head - 1 >= 0 )
		{
			snake[head].x = snake[head - 1].x + 1;
			snake[head].y = snake[head - 1].y;
		}else 
		{
			snake[head].x = snake[MAX_SIZE -1].x + 1;
			snake[head].y = snake[MAX_SIZE -1].y;			
		}		
	}

	//check the snake went out
	if (snake[head].x <= 0 || snake[head].y <= 0 ||
		snake[head].x >= 48 ||snake[head].y >=80 )
	{
		defeat = 1;
	}

	//check snake got the food!!
	if ( snake[head].x == point.x && snake[head].y == point.y)
	{
		tail--;
		set_pixel(point.x,point.y, 0);
		getRandPosition(&point.x, &point.y);
		score ++;
	}
}

void start_lcd(void)
{
	// Setup LCD
	lcd_init();
	lcd_contrast(0x40);
	
	// Print on first line
	lcd_goto_xy(1,1);
	lcd_str("SNAKE");
	lcd_str(" -> Apasa orice tasta");
	while((PINB & (1 << PB0)) != 0 &&
		(PINB & (1 << PB1)) != 0 &&
		(PINB & (1 << PB2)) != 0 &&
		(PINB & (1 << PB3)) != 0);
	lcd_clear();
}

int main(void) {
	srand(0);
	init_snake();
	initButtons();
	set_snake();

	start_lcd();
	draw_matrix();

	while(1)
	{
		get_direction();
		advance();
		set_snake();
		draw_matrix();
		if (defeat == 1)
		{
			lcd_clear();
			//lcd_goto_xy(50,40);
			//lcd_str("Game over :(");
			lcd_goto_xy(50,40);
			lcd_chr(score + '0');
			break;
		}
		_delay_ms(150);
	}

	while(1);

}



